<template>
  <div>
    {{ defaults }}
    {{ config.title }}
    <div v-for="(text, key) in config.values" :key="key">
      <input type="checkbox" :id="[parentConfig.path, key].join('.')" :value="key" v-model="fieldData">
      <label :for="[parentConfig.path, key].join('.')">{{ text }}</label>
    </div>
  </div>
</template>

<script>

import _ from 'lodash'
// import { EDITABLE_FIELD_CONFIG } from '@/config'

import { mapGetters, mapActions } from 'vuex'

export default {
  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    },
    // config: {
    //   type: Object,
    //   required: true
    // }
    field: {
      type: String,
      required: true
    },
    defaults: {
      required: false
    }
  },

  data () {
    return {
    }
  },

  computed: {
    ...mapGetters({
      getEditedField: 'Y3TI/getEditedField',
      getFieldConfig: 'Y3TI/getFieldConfig'
    }),

    parentConfig () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },

    config () {
      return _.get(this.parentConfig, [ 'description', this.field ], {})
    },
    // options () {
    //   return _.get(this.config, [ 'description', this.field, 'values' ], {})
    // },

    // default () {
    //   return _.get(this.config, [ 'description', this.field, 'default' ])
    // },

    fieldData: {
      get () {
        let data = this.getEditedField({ node: this.node, path: [...this.path, this.field] })
        return !data ? _.get(this.defaults, this.field) || data : data
        // data = !data ? (this.config.default || data) : data
        // data = !_.isArray(data) ? [data] : data
        // return data
      },
      set (value) {
        this.storeEditableFieldData({ data: { node: this.node, path: [ ...this.path, this.field ], input: value } })
      }
    }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...[this.config.path] ]
    // }
  },

  methods: {
    ...mapActions({
      storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    })
  }
}
</script>

<style lang="scss" scoped>
</style>
